#ifndef __DB_SYSTEM_H__
#define __DB_SYSTEM_H__

#include "db_types.h"

#define MAXLINE 128

typedef struct {
    uint8_t *freeSpace;     /* base of free space */
    uint8_t *freeMark;      /* mark the end of the permanently allocated space */
    uint8_t *freeNext;      /* next free space available */
    uint8_t *freeTop;       /* top of free space */
    char lineBuf[MAXLINE];  /* line buffer */
    char *linePtr;          /* pointer to the current character */
} System;

void InitFreeSpace(System *sys, uint8_t *space, size_t size);
void MarkFreeSpace(System *sys);
void ResetFreeSpace(System *sys);
uint8_t *AllocateFreeSpace(System *sys, size_t size);
uint8_t *AllocateAllFreeSpace(System *sys, size_t *pSize);

#endif
